import matplotlib.pyplot as plt
import pandas as pd
import numpy as np
import glob, os, sys
from IPython.core.debugger import set_trace
from nltk.corpus import stopwords
from nltk.tokenize import word_tokenize
import string
import unicodedata
from nltk.stem.wordnet import WordNetLemmatizer
from nltk import pos_tag
from nltk.corpus import wordnet
from collections import Counter 

# Einlesen von mehreren csv Dateien in ein Dataframe. Unter dem path soll ein Path zu CSV-Ordner eingegegben werden.
path = r'.\extracted\**'
all_rec = glob.iglob(os.path.join(path, "*.csv"), recursive=True)     
dataframes = (pd.read_csv(f, names="Time URL Country Paper Article".split()) for f in all_rec)
big_dataframe = pd.concat(dataframes, ignore_index=False)

# Reset von Indizies
big_dataframe.reset_index(inplace=True, drop=True) 

# löscht alle leeren Artikeln - (Videoseiten)  und Duplikate
big_dataframe.dropna(inplace=True) 
big_dataframe.drop_duplicates(subset=["URL", "Article", "Paper", "Country"], inplace=True)
big_dataframe.reset_index(inplace=True, drop=True) 


big_dataframe["Length before"] = big_dataframe["Article"].apply(length_count) 
big_dataframe = shortPreprocessing(big_dataframe)
big_dataframe["Length after"] = big_dataframe["Article"].apply(length_count) 

# Length difference
au_dataframe["Length differnce"] = au_dataframe["Length before"]-au_dataframe["Length after"]

# Speichern von DataFrame
big_dataframe.to_pickle(".\dataframe_all")


# Länge der Artikeln bestimmen
def length_count(article):
    return len(article.split())



### Preprocessing - WORKING VERSION ###
# Hier werden Stopwörter und Satzzeichen rausgelöscht. Außerdem wird ein Lemmatizer angewendet, um 
# unterschiedlichen Formen von Worten zu vermeiden. 
def shortPreprocessing(b_dataframe):

    stop_words = set(stopwords.words("english"))

    # Iteriert über alle Artikeln und übergibt Zeilenindex von einem Artikel (art_index) und Artikel selbst (art)
    for article_index,article in b_dataframe["Article"].astype("U").iteritems():
        
        # Löscht alle Unicode-Zeichen
        decodedString = (article.encode("ascii", "ignore")).decode("utf-8")
        
        #set_trace()
        
        # Checkt jedes Zeichen, ob es ein Satzzeichen ist
        nopunc = [char for char in decodedString if char not in string.punctuation]
    
        # Alle Zeichen wieder zurückjoinen
        nopunc = "".join(nopunc)
        
        filtered_words = [lem(word) for word in nopunc.split() if word.lower() not in stop_words]
        
        filtered_text = " ".join(filtered_words)
    
        b_dataframe.set_value(article_index, "Article", filtered_text)
    return b_dataframe

### Part of Speech Implementierung ###
def get_pos( word ):
    w_synsets = wordnet.synsets(word)

    pos_counts = Counter()
    pos_counts["n"] = len(  [ item for item in w_synsets if item.pos()=="n"]  )
    pos_counts["v"] = len(  [ item for item in w_synsets if item.pos()=="v"]  )
    pos_counts["a"] = len(  [ item for item in w_synsets if item.pos()=="a"]  )
    pos_counts["r"] = len(  [ item for item in w_synsets if item.pos()=="r"]  )
    
    most_common_pos_list = pos_counts.most_common(3)
    return most_common_pos_list[0][0] 

cache = {}
wnl = WordNetLemmatizer()

### Lemmatizer ###
def lem(w):
    if w in cache:
        return cache[w]
    else:
        cache[w] = wnl.lemmatize(w, get_pos(w))
        return wnl.lemmatize(w, get_pos(w))
